﻿using HanyadikHetVan.Data.Entities;
using HanyadikHetVan.Interface;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Internal;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace HanyadikHetVan.Services
{
    public class WeeklyTimeSpanService
    {
        private readonly IRepository<WeeklyTimeSpan> _weeklytimespan;

        public WeeklyTimeSpanService(IRepository<WeeklyTimeSpan> weeklytimespan)
        {
            _weeklytimespan = weeklytimespan ?? throw new ArgumentNullException(nameof(weeklytimespan));
        }

        public IEnumerable<WeeklyTimeSpan> GetAllWeeklyTimeSpans()
        {
            return _weeklytimespan.GetAll().ToList();
        }

        public WeeklyTimeSpan GetWeeklyTimeSpan(int weeklytimespanId)
        {
            return _weeklytimespan.GetAll().Where(x => x.Id == weeklytimespanId).FirstOrDefault();
        }

        public ICollection<Pause> GetPausesOfWeeklyTimeSpan(int weeklytimespanId)
        {
            return _weeklytimespan.GetAll().Where(x => x.Id == weeklytimespanId).FirstOrDefault().Pauses;
        }

        public IEnumerable<WeeklyTimeSpan> GetWeeklyTimeSpanByStartdate(DateTime startTime)
        {
            return _weeklytimespan.GetAll().Where(x => x.Startdate.Date.Equals(startTime.Date)).ToList();
        }

        public async Task<WeeklyTimeSpan> AddWeeklyTimeSpan(WeeklyTimeSpan weeklytimespan)
        {
            return await _weeklytimespan.Create(weeklytimespan);
        }

        public bool DeleteWeeklyTimeSpan(int weeklytimespanId)
        {
            try
            {
                var item = _weeklytimespan.GetAll().Where(x => x.Id == weeklytimespanId).FirstOrDefault();
                _weeklytimespan.Delete(item);
                return true;
            }
            catch (Exception)
            {
                return false;
            }
        }

        public bool UpdateWeeklyTimeSpan(WeeklyTimeSpan weeklytimespan)
        {
            try
            {
                var DataList = _weeklytimespan.GetAll().ToList();
                foreach (var item in DataList)
                {
                    _weeklytimespan.Update(item);
                }
                return true;
            }
            catch (Exception)
            {
                return true;
            }
        }
    }
}
